//----------------------------------------------------------------------------
//COPYRIGHT (C) 2005 SEGWAY INC.
//
//Segway provides this software "as is" with no warranty of any kind
//either expressed or implied, including, but not limited to the 
//implied warranties of merchantability, fitness for a particular 
//purpose, and noninfringement.
//
//Permission is granted to copy and modify this software for usage on 
//the RMP development platform.
//
//----------------------------------------------------------------------------
///	\file		usb_int.h
///	\brief
///
///	- Author:	Eric L Pribyl
///	- Date:		May 2005
///
///Description:
///Public header to the deuce_int.cpp module.
///
///


#ifndef _USB_INT_H
#define _USB_INT_H


#ifdef WIN32
#include <windows.h>
#endif
#include "ftd2xx.h"

int	usb_init();

bool usb_active();

extern FT_HANDLE usb_ftHandle;
int usb_can_init();
int usb_can_send(int channel, int id, unsigned short *data);
int	usb_can_dma(int onoff);
int usb_wake(int onoff);
int usb_reset();

int usb_LoadDLL();
int usb_closedll();

unsigned int usb_XModem_Send(unsigned char*, unsigned int);


typedef FT_STATUS (WINAPI *PtrToWrite)(FT_HANDLE, LPVOID, DWORD, LPDWORD);
FT_STATUS usb_Write(LPVOID, DWORD, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToOpen)(PVOID, FT_HANDLE *); 
FT_STATUS usb_Open(PVOID);

typedef FT_STATUS (WINAPI *PtrToOpenEx)(PVOID, DWORD, FT_HANDLE *); 
FT_STATUS usb_OpenEx(PVOID, DWORD);

typedef FT_STATUS (WINAPI *PtrToListDevices)(PVOID, PVOID, DWORD);
FT_STATUS usb_ListDevices(PVOID, PVOID, DWORD);

typedef FT_STATUS (WINAPI *PtrToClose)(FT_HANDLE);
FT_STATUS usb_Close();

typedef FT_STATUS (WINAPI *PtrToRead)(FT_HANDLE, LPVOID, DWORD, LPDWORD);
FT_STATUS usb_Read(LPVOID, DWORD, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToResetDevice)(FT_HANDLE);
FT_STATUS usb_ResetDevice();
	
typedef FT_STATUS (WINAPI *PtrToPurge)(FT_HANDLE, ULONG);
FT_STATUS usb_Purge(ULONG);
	
typedef FT_STATUS (WINAPI *PtrToSetTimeouts)(FT_HANDLE, ULONG, ULONG);
FT_STATUS usb_SetTimeouts(ULONG, ULONG);

typedef FT_STATUS (WINAPI *PtrToGetQueueStatus)(FT_HANDLE, LPDWORD);
FT_STATUS usb_GetQueueStatus(LPDWORD);

typedef FT_STATUS (WINAPI *PtrToSetBaudRate)(FT_HANDLE, ULONG);
FT_STATUS usb_SetBaudRate(ULONG);

typedef FT_STATUS (WINAPI *PtrToSetLatencyTimer)(FT_HANDLE, UCHAR);
FT_STATUS usb_SetLatencyTimer(UCHAR);

extern PtrToWrite usb_pWrite;
extern PtrToOpen usb_pOpen; 
extern PtrToOpenEx usb_pOpenEx; 
extern PtrToListDevices usb_pListDevices; 
extern PtrToClose usb_pClose;
extern PtrToRead usb_pRead;
extern PtrToResetDevice usb_pResetDevice;
extern PtrToPurge usb_pPurge;
extern PtrToSetTimeouts usb_pSetTimeouts;
extern PtrToGetQueueStatus usb_pGetQueueStatus;
extern PtrToSetBaudRate usb_pSetBaudRate;
extern PtrToSetLatencyTimer usb_pSetLatencyTimer;

int usb_message_format(unsigned char *sbytes);


#endif
